#include <stdio.h>
#include <memory.h>

unsigned lights;
unsigned switche[31];
int s[31];
int done;
int N, M;
int depth;

int ones(unsigned light)
{
	int sum = 0;
	for (int i = 0; i < N; i++)
		if (light & (1 << i))
			sum++;
	return sum;
}

void Rekurz(int last)
{
	if (depth++ > 100)
		return;
	if (done)
		return;
	int test[31] = {0};
	
	int which = 0;
	int max = 0;
	
	for (int k = 0; k < M; k++)
	{
	for (int i = 0; i < M; i++)
		if ((!test[i]) && (i != last))
		{
			int res = ones(lights ^ switche[i]);
			if (res > max)
			{
				max = res;
				which = i;
			}
		}
		
	lights ^= switche[which];
	s[which] = !s[which];
	
	if (max == N)
	{
		done = 1;
		for (int i = 0; i < M; i++)
			if (s[i])
				printf("%d ", i + 1);
		printf("\n");
		return;
	}
	
	test[which] = 1;
	Rekurz(which);
	if (done)
		return;
	lights ^= switche[which];
	s[which] = !s[which];
	}
	
}

int main()
{
	int n;
	scanf("%d", &n);
	while (n--)
	{
		scanf("%d %d", &N, &M);
		lights = 0;
		for (int i = 0; i < N; i++)
		{
			int onoff;
			scanf("%d", &onoff);
			lights |= onoff << i;
		}	
		memset(switche, 0, sizeof(switche));
		for (int i = 0; i < M; i++)
		{
			while (1)
			{
				unsigned onoff;
				scanf("%d", &onoff);
				if (!onoff)
					break;
				switche[i] |= 1 << (onoff - 1);
			}
		}
		
		memset(s, 0, sizeof(s));
		
		done = 0;
		depth = 0;
		Rekurz(99);
		if (!done)
			printf("Impossible\n");

		
			
	}
}